from dbpool import getConnection, getMany, getOne
from auth import check_scope

def get_mieters(token_info):
    check_scope(token_info, [ "mieter/read", "wohnung/read", "objekt/read" ])
    return getMany("""
SELECT m.id as id, 
       o.id as objekt,
       w.id as wohnung,
       w.shortname as wohnung_shortname, 
       o.shortname as objekt_shortname,
       COALESCE(m.anrede, '-') as anrede,
       COALESCE(m.vorname, '-') as vorname,
       m.nachname as nachname,
       COALESCE(m.strasse, '-') as strasse,
       COALESCE(m.plz, '-') as plz,
       COALESCE(m.ort, '-') as ort,
       COALESCE(m.telefon, '-') as telefon,
       m.einzug as einzug,
       COALESCE(m.auszug, '-') as auszug
  FROM wohnung w, objekt o, mieter m
  WHERE o.id = w.objekt AND
        w.id = m.wohnung
    """, [], "Mieter")

def get_mieter(id, token_info):
    check_scope(token_info, [ "mieter/read", "wohnung/read", "objekt/read" ])
    return getOne("""
SELECT m.id as id, 
       o.id as objekt,
       w.id as wohnung,
       w.shortname as wohnung_shortname, 
       o.shortname as objekt_shortname,
       COALESCE(m.anrede, '-') as anrede,
       COALESCE(m.vorname, '-') as vorname,
       m.nachname as nachname,
       COALESCE(m.strasse, '-') as strasse,
       COALESCE(m.plz, '-') as plz,
       COALESCE(m.ort, '-') as ort,
       COALESCE(m.telefon, '-') as telefon,
       m.einzug as einzug,
       COALESCE(m.auszug, '-') as auszug
  FROM wohnung w, objekt o, mieter m
  WHERE o.id = w.objekt AND
        w.id = m.wohnung AND
        m.id = ?
""", (id, ), "Mieter")
